#ifndef KANIMAJI_ERROR_HPP
#define KANIMAJI_ERROR_HPP

#include <cstddef>
#include <stdexcept>
#include <string_view>

namespace Kanimaji
{
    class Error : public std::runtime_error
    {
        using std::runtime_error::runtime_error;
    };

    class FileError : public Error
    {
        using Error::Error;
    };

    class ParseError : public Error
    {
    public:
        ParseError(std::size_t current, std::string_view message);

        std::size_t Position() const
        {
            return mPosition;
        }
    private:
        std::size_t mPosition;
    };
}

#endif // KANIMAJI_ERROR_HPP
